#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <windows.h>

#include "WFCUtil.h"
#include "WFC_defines.h"


//global
char gDialogString[1024];
char confirmedKeyStr[256];
bool assertDone;
bool keysMatch;
HWND confirmKeyEdit = NULL;

extern DWORD mainWFCThreadID, doEncryptThreadID;


//xors plaintext (p) with ciphertext(c)
void XORBlock(unsigned char *c, unsigned char *p, int blocksz)
{
	int i = 0;

	while(i < blocksz)
	{
		p[i] ^= c[i];
		i++;
	}
}


char* NoQuotes(char* instr)
{
	if(strlen(instr) > 1024)
		return NULL;

	char* outstr;
	char tempstr[2048];	//static length not good
	int ti = 0;

	for(unsigned int i = 0; i < strlen(instr); i++)
	{
		if(instr[i] != '\"') {
			tempstr[ti] = instr[i];
			ti++;
		}
	}
	tempstr[ti] = '\0';

	outstr = new char[strlen(tempstr)];

	strcpy(outstr, tempstr);

	return outstr;
}


char* RemoveQuotes(char *string)
{
	unsigned int i;
	char *dest;

	if(string[0] == '\"')
	{
		for(i = 1; i < strlen(string) && string[i] != '\"'; i++);
		dest = new char [i+1];
		memcpy(dest, string+1, i-1);
		dest[i-1] = '\0';
	}

	else
	{
		int len = strlen(string)+1;
		dest = new char [len];
		memcpy(dest, string, len);
	}

	return dest;
}

int GetTextFromControl(HWND control, char* dest, int len)
{
	int *bufsz = (int*) dest;

	*bufsz = len+1;

	int nchar = SendMessage(control, EM_GETLINE, 0 /*first line*/, (long) dest);
	dest[nchar] = '\0';

	return nchar;
}

bool WFCConfirmKey(HINSTANCE hInstance, HWND hParentWin, char* keystr)
{
	assertDone = false;

	keysMatch = false;
	RECT parentRect;
	strcpy(gDialogString, "Confirm key:");

	GetWindowRect(hParentWin, &parentRect);

	HWND hConfirmWin = CreateWindow(APPNAME, "Confirm", WS_EX_DLGMODALFRAME | WS_VISIBLE,
		parentRect.left, parentRect.top+75, 250, 200,
		NULL, NULL, hInstance, NULL);

	SetWindowFontDefault(hConfirmWin);

	HWND hConfirmEdit = CreateWindow("edit", "", WS_VISIBLE | WS_BORDER | WS_CHILD | ES_LEFT | ES_AUTOHSCROLL | ES_PASSWORD,
		25, 75, 200, 20, hConfirmWin, 0, hInstance, NULL);
	confirmKeyEdit = hConfirmEdit;
	SetWindowFontDefault(hConfirmEdit);

	HWND hOkBtn = CreateWindow("button", "Ok", WS_VISIBLE | WS_BORDER | WS_CHILD,
		85, 120, 75, 30, hConfirmWin, 0, hInstance, NULL);
	SetWindowFontDefault(hOkBtn);

	SetWindowLong(hConfirmWin, GWL_WNDPROC, (LONG) WFCUtilWinProc);
	SetBkColor(GetDC(hConfirmWin), GetSysColor(COLOR_3DFACE));
	
	SetFocus(hConfirmEdit);
	
	//disable events from reaching parent window
	EnableWindow(hParentWin, false);

	while(IsWindowVisible(hConfirmWin))
	{
		MSG msg;

		GetMessage(&msg, NULL, 0, 0);

		if(assertDone == true) {
			char *buf = new char[WFC_BUFSZ1];
			
			GetTextFromControl(hConfirmEdit, buf, WFC_BUFSZ1);
			
			if(strcmp(buf, keystr) == 0)
				keysMatch = true;

			delete buf;
			break;
		}

		if(msg.message == WM_KEYDOWN || msg.message == WM_KEYUP)
			TranslateMessage(&msg);

		DispatchMessage(&msg);
	}

	//reenable input
	EnableWindow(hParentWin, true);
	SetFocus(hParentWin);

	DestroyWindow(hConfirmWin);

	return keysMatch;
}
		

bool WFCAssert(bool c, char *string, HINSTANCE hInstance, HWND hParentWin)
{
	assertDone = false;

	if(c)
	{
		RECT parentRect, assertWinRect;
		int OkBtnWidth = 50, OkBtnHeight = 30;
		
		GetWindowRect(hParentWin, &parentRect);

		HWND hAssertWin = CreateWindow(APPNAME, "Assert", WS_EX_DLGMODALFRAME | WS_VISIBLE, 
			parentRect.left, parentRect.top+75, 250, 170,
			NULL, NULL, hInstance, NULL);

		SetWindowFontDefault(hAssertWin);

		GetWindowRect(hAssertWin, &assertWinRect);

		HWND hOkBtn = CreateWindow("button", "Ok", WS_VISIBLE | WS_BORDER | WS_CHILD,
			(assertWinRect.right-assertWinRect.left)/2 - (OkBtnWidth/2),
			(assertWinRect.bottom-assertWinRect.top)/2,
			OkBtnWidth, OkBtnHeight, hAssertWin, 0, hInstance, NULL);

		SetWindowFontDefault(hOkBtn);

		
		/*setup window*/
		SetWindowLong(hAssertWin, GWL_WNDPROC, (LONG) WFCUtilWinProc);
		SetBkColor(GetDC(hAssertWin), GetSysColor(COLOR_3DFACE));

		strcpy(gDialogString, string);

		/*bring this window to the front*/
		SetActiveWindow(hAssertWin);

		EnableWindow(hParentWin, false);
	
		while(IsWindowVisible(hAssertWin))
		{
			if(assertDone == true)
				break;

			MSG msg;
			GetMessage(&msg, NULL, 0, 0);

			if(msg.message == WM_KEYDOWN || msg.message == WM_KEYUP)
				TranslateMessage(&msg);

			DispatchMessage(&msg);
		}

		EnableWindow(hParentWin, true);
		SetFocus(hParentWin);

		DestroyWindow(hAssertWin);
	}

	return c;
}

LRESULT CALLBACK WFCUtilWinProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT painter;

	switch(uMsg)
	{
	case WM_PAINT:
		{
			BeginPaint(hwnd, &painter);
			{
				RECT txtRect, winRect;
				float txtWidth = strlen(gDialogString) * /*width of a char...*/ (float) 6.5;
				float winWidth;

				GetWindowRect(hwnd, &winRect);

				winWidth = (float) winRect.right-winRect.left;

				int mleft = (int) (winWidth/2.0) - (int) (txtWidth/2.0);
				int mright = (int) (winWidth/2.0) + (int) (txtWidth/2.0);

				SetRect(&txtRect, mleft, 40, mright, 60);

				ExtTextOut(GetDC(hwnd), txtRect.left, txtRect.top, NULL,
					&txtRect, gDialogString, strlen(gDialogString), NULL);
			}
			EndPaint(hwnd, &painter);
		} break;
			
	case WM_COMMAND:
		{
			if(HIWORD(wParam) == BN_CLICKED) {
				assertDone = true;
			}
		} break;

	default:
		break;
	}

	return DefWindowProc(hwnd, uMsg, wParam, lParam);	//stop complaints
}
		

void MemSetRand(void *data, unsigned int len)
{
	for(unsigned int i = 0; i < len; i++)
		((char *) data)[i] = rand();
}

void ListBoxAddString(HWND listbox, char* string)
{
	SendMessage(listbox, LB_ADDSTRING, NULL, (long) string);
}

void SetWindowFontDefault(HWND win)
{
	HFONT logfont = (HFONT) GetStockObject(DEFAULT_GUI_FONT);
	DWORD redraw;
	redraw = 0xFFFFFFFF;
	SendMessage(win, WM_SETFONT, (unsigned int) logfont, (long) &redraw);

	SelectObject(GetDC(win), logfont);
}